package contorllogic;

import java.math.BigDecimal;

/**
 * △P 计算  通过△f
 * △P = 目标有功- 当前有功
 * <p>
 * △P=-1/δ%*Pn*△f/fn
 */
public class PowerVariationCalculator {


    /**
     * 装机容量
     */
    private BigDecimal Pn=BigDecimal.valueOf(50);

    /**
     * 额定频率
     */
    private BigDecimal Fn=BigDecimal.valueOf(50);


    /**
     * 调差率
     */
    private BigDecimal slope=BigDecimal.valueOf(3);


    /**
     *  计算需要调节的有功的变化值
     * @param f 频率
     * @return  有功变化调节值
     */
    public  BigDecimal calculate(BigDecimal f){
        BigDecimal g1 = BigDecimal.valueOf(-100).divide(slope, 2, BigDecimal.ROUND_HALF_UP);
        BigDecimal g2 = f.subtract(Fn).divide(Fn, 2, BigDecimal.ROUND_HALF_UP);
        return  g1.multiply(Pn).multiply(g2);
    }







}
