package fmprotocol;

import lombok.Setter;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

@Setter
public class DataBean {

    //频率
    private BigDecimal F=BigDecimal.valueOf(-99);


    //A相电压
    private BigDecimal Ua=BigDecimal.valueOf(-99);
    //B相电压
    private BigDecimal Ub=BigDecimal.valueOf(-99);
    //C相电压
    private BigDecimal Uc=BigDecimal.valueOf(-99);


    //A相电流
    private BigDecimal Ia=BigDecimal.valueOf(-99);
    //B相电流
    private BigDecimal Ib=BigDecimal.valueOf(-99);
    //C相电流
    private BigDecimal Ic=BigDecimal.valueOf(-99);


    //A相有功
    private BigDecimal Pa=BigDecimal.valueOf(-99);
    //B相有功
    private BigDecimal Pb=BigDecimal.valueOf(-99);
    //C相有功
    private BigDecimal Pc=BigDecimal.valueOf(-99);


    //A相无功
    private BigDecimal Qa=BigDecimal.valueOf(-99);
    //B相无功
    private BigDecimal Qb=BigDecimal.valueOf(-99);
    //C相无功
    private BigDecimal Qc=BigDecimal.valueOf(-99);


    //A相视在功率
    private BigDecimal Sa=BigDecimal.valueOf(-99);
    //B相视在功率
    private BigDecimal Sb=BigDecimal.valueOf(-99);
    //C相视在功率
    private BigDecimal Sc=BigDecimal.valueOf(-99);


    //A相未发生过流
    private Boolean OIIa = false;
    //B相未发生过流
    private Boolean OIIb = false;
    //C相未发生过流
    private Boolean OIIc = false;


    //A相未发生过压
    private Boolean OVUa = false;
    //B相未发生过压
    private Boolean OVUb = false;
    //C相未发生过压
    private Boolean OVUc = false;


    //A相是否失压
    private Boolean LostVoltA = false;
    //B相是否失压
    private Boolean LostVoltB = false;
    //C相是否失压
    private Boolean LostVoltC = false;


    //电压相序是否异常
    private Boolean UPhSqErr = false;


    public String toString() {
        return "频率：" + F + " ;   </br>" +
                "A相电压：" + Ua + " ;   B相电压：" + Ub + " ;   C相电压：" + Uc + " ;   </br>" +
                "A相电流：" + Ia + " ;   B相电流：" + Ib + " ;   C相电流：" + Ic + " ;   </br>" +
                "A相有功：" + Pa + " ;   B相有功：" + Pb + " ;   C相有功：" + Pc + " ;   </br>" +
                "A相无功：" + Qa + " ;   B相无功：" + Qb + " ;   C相无功：" + Qc + " ;   </br>" +
                "A相视在：" + Sa + " ;   B相视在：" + Sb + " ;   C相视在：" + Sc + " ;   </br>" +
                "A相过流：" + (OIIa ? "是" : "否") + " ;   B相过流：" + (OIIb ? "是" : "否") + " ;   C相过流：" + (OIIc ? "是" : "否") + " ;   </br>" +
                "A相过压：" + (OVUa ? "是" : "否") + " ;   B相过压：" + (OVUb ? "是" : "否") + " ;   C相过压：" + (OVUc ? "是" : "否") + " ;   </br>" +
                "A相失压：" + (LostVoltA ? "是" : "否") + " ;   B相失压：" + (LostVoltB ? "是" : "否") + " ;   C相失压：" + (LostVoltC ? "是" : "否") + " ;   </br>" +
                "电压相序：" + (UPhSqErr ? "异常" : "正常");

    }


    public String toWebString() {
        return "频率：" + F + " ;   </br>" +
                "A相电压：" + Ua + " ;   B相电压：" + Ub + " ;   C相电压：" + Uc + " ;   </br>" +
                "A相电流：" + Ia + " ;   B相电流：" + Ib + " ;   C相电流：" + Ic + " ;   </br>" +
                "A相有功：" + Pa + " ;   B相有功：" + Pb + " ;   C相有功：" + Pc + " ;   </br>" +
                "A相无功：" + Qa + " ;   B相无功：" + Qb + " ;   C相无功：" + Qc + " ;   </br>" +
                "A相视在：" + Sa + " ;   B相视在：" + Sb + " ;   C相视在：" + Sc + " ;   </br>" +
                "A相过流：" + (OIIa ? "是" : "否") + " ;   B相过流：" + (OIIb ? "是" : "否") + " ;   C相过流：" + (OIIc ? "是" : "否") + " ;   </br>" +
                "A相过压：" + (OVUa ? "是" : "否") + " ;   B相过压：" + (OVUb ? "是" : "否") + " ;   C相过压：" + (OVUc ? "是" : "否") + " ;   </br>" +
                "A相失压：" + (LostVoltA ? "是" : "否") + " ;   B相失压：" + (LostVoltB ? "是" : "否") + " ;   C相失压：" + (LostVoltC ? "是" : "否") + " ;   </br>" +
                "电压相序：" + (UPhSqErr ? "异常" : "正常");

    }


    public List<String> toWebDataList() {
       List<String> list=new ArrayList<>();
       list.add(F.toString());
       list.add(Ua.toString());
        list.add(Ub.toString());
        list.add(Uc.toString());
        list.add(Ia.toString());
        list.add(Ib.toString());
        list.add(Ic.toString());
        list.add(Pa.toString());
        list.add(Pb.toString());
        list.add(Pc.toString());
        list.add(Qa.toString());
        list.add(Qb.toString());
        list.add(Qc.toString());
        list.add(Sa.toString());
        list.add(Sb.toString());
        list.add(Sc.toString());

        list.add(OIIa?"是":"否");
        list.add(OIIb?"是":"否");
        list.add(OIIc?"是":"否");
        list.add(OVUa?"是":"否");
        list.add(OVUb?"是":"否");
        list.add(OVUc?"是":"否");

        list.add(LostVoltA?"是":"否");
        list.add(LostVoltB?"是":"否");
        list.add(LostVoltC?"是":"否");
        list.add(UPhSqErr?"是":"否");
        return list;
    }
}
