package fmprotocol;

import io.netty.buffer.ByteBuf;

import java.math.BigDecimal;
import java.math.RoundingMode;

public class DataBeanPacker {


    private DataBean lastDataBean = new DataBean();


    private DataBeanPacker() {
    }


    private static class LazyHolder {
        private static final DataBeanPacker INSTANCE = new DataBeanPacker();
    }

    /**
     * 获取单例实例
     *
     * @return the instance
     */
    public static final DataBeanPacker getInstance() {
        return DataBeanPacker.LazyHolder.INSTANCE;
    }

    public synchronized DataBean getLastDataBean() {
        return this.lastDataBean;
    }

    public synchronized DataBean setLastDataBean(DataBean dataBean) {
        this.lastDataBean = dataBean;
        return this.lastDataBean;
    }

    public DataBean decodeAnRecode(ByteBuf byteBuf) {
        return setLastDataBean(decode(byteBuf));
    }


    public static DataBean decode(ByteBuf byteBuf) {
        byteBuf.readInt();
        DataBean dataBean = new DataBean();
        dataBean.setUa(decodeBA(byteBuf).divide(BigDecimal.valueOf(100), 2, RoundingMode.HALF_UP));
        dataBean.setUb(decodeBA(byteBuf).divide(BigDecimal.valueOf(100), 2, RoundingMode.HALF_UP));
        dataBean.setUc(decodeBA(byteBuf).divide(BigDecimal.valueOf(100), 2, RoundingMode.HALF_UP));


        dataBean.setIa(decodeBA(byteBuf).divide(BigDecimal.valueOf(10), 1, RoundingMode.HALF_UP));
        dataBean.setIb(decodeBA(byteBuf).divide(BigDecimal.valueOf(10), 1, RoundingMode.HALF_UP));
        dataBean.setIc(decodeBA(byteBuf).divide(BigDecimal.valueOf(10), 1, RoundingMode.HALF_UP));


        dataBean.setPa(decodeDCBA(byteBuf).divide(BigDecimal.valueOf(1000), 3, RoundingMode.HALF_UP));
        dataBean.setPb(decodeDCBA(byteBuf).divide(BigDecimal.valueOf(1000), 3, RoundingMode.HALF_UP));
        dataBean.setPc(decodeDCBA(byteBuf).divide(BigDecimal.valueOf(1000), 3, RoundingMode.HALF_UP));


        dataBean.setQa(decodeDCBA(byteBuf).divide(BigDecimal.valueOf(1000), 3, RoundingMode.HALF_UP));
        dataBean.setQb(decodeDCBA(byteBuf).divide(BigDecimal.valueOf(1000), 3, RoundingMode.HALF_UP));
        dataBean.setQc(decodeDCBA(byteBuf).divide(BigDecimal.valueOf(1000), 3, RoundingMode.HALF_UP));


        dataBean.setSa(decodeDCBA(byteBuf).divide(BigDecimal.valueOf(1000), 3, RoundingMode.HALF_UP));
        dataBean.setSb(decodeDCBA(byteBuf).divide(BigDecimal.valueOf(1000), 3, RoundingMode.HALF_UP));
        dataBean.setSc(decodeDCBA(byteBuf).divide(BigDecimal.valueOf(1000), 3, RoundingMode.HALF_UP));


        dataBean.setF(decodeBA(byteBuf).divide(BigDecimal.valueOf(1000), 3, RoundingMode.HALF_UP));

        byte b = byteBuf.readByte();
        dataBean.setOVUc((byte) ((b) & 0x01) == 0x01);
        dataBean.setOVUb((byte) ((b >> 1) & 0x01) == 0x01);
        dataBean.setOVUa((byte) ((b >> 2) & 0x01) == 0x01);
        dataBean.setOIIc((byte) ((b >> 3) & 0x01) == 0x01);
        dataBean.setOIIb((byte) ((b >> 4) & 0x01) == 0x01);
        dataBean.setOIIa((byte) ((b >> 5) & 0x01) == 0x01);
        b = byteBuf.readByte();
        dataBean.setLostVoltC((byte) ((b) & 0x01) == 0x01);
        dataBean.setLostVoltB((byte) ((b >> 1) & 0x01) == 0x01);
        dataBean.setLostVoltA((byte) ((b >> 2) & 0x01) == 0x01);
        dataBean.setUPhSqErr((byte) ((b >> 3) & 0x01) == 0x01);
        return dataBean;
    }


    private static BigDecimal decodeBA(ByteBuf byteBuf) {
        return BigDecimal.valueOf(((byteBuf.readByte() & 0xff) | ((byteBuf.readByte() & 0xff) << 8)));
    }


    private static BigDecimal decodeDCBA(ByteBuf byteBuf) {
        return BigDecimal.valueOf((byteBuf.readByte() & 0xff) | ((byteBuf.readByte() & 0xff) << 8)
                | ((byteBuf.readByte() & 0xff) << 16) | ((byteBuf.readByte() & 0xff) << 24));
    }

    private static BigDecimal decode_F_DCBA(ByteBuf byteBuf) {
       return new BigDecimal(Float.toString(Float.intBitsToFloat((byteBuf.readByte() & 0xff) | ((byteBuf.readByte() & 0xff) << 8)
                | ((byteBuf.readByte() & 0xff) << 16) | ((byteBuf.readByte() & 0xff) << 24))));
    }
    private static BigDecimal decode_F_BA(ByteBuf byteBuf) {
        return new BigDecimal(Float.toString(Float.intBitsToFloat((byteBuf.readByte() & 0xff) | ((byteBuf.readByte() & 0xff) << 8))));
    }
}
