package fmprotocol;

import lombok.experimental.Accessors;
import lombok.extern.slf4j.Slf4j;
import wei.yigulu.netty.AbstractRtuModeBuilder;
import wei.yigulu.netty.ProtocolChannelInitializer;
import wei.yigulu.purejavacomm.PureJavaCommChannel;

/**
 * cdt的客户端
 *
 * @author: xiuwei
 * @version:
 */
@Accessors(chain = true)
@Slf4j
public class FmRtuMasterBuilder extends AbstractRtuModeBuilder {


    public FmRtuMasterBuilder(String commPortId) {
        super(commPortId);
    }

    @Override
    protected ProtocolChannelInitializer getOrCreateChannelInitializer() {
        if (this.channelInitializer == null) {
            this.channelInitializer = new ProtocolChannelInitializer<PureJavaCommChannel>(this) {
                @Override
                protected void initChannel(PureJavaCommChannel ch) throws Exception {
                    ch.pipeline().addLast(new FmRtuMasterDelimiterHandler().setLog(getLog()));
                    ch.pipeline().addLast(new FmRtuMasterHandler((FmRtuMasterBuilder) builder));
                }
            };
        }
        return this.channelInitializer;
    }
}
